/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_LengthCorrectOp_h__
#define __operator_LengthCorrectOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to resize curve segments to match an original

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT LengthCorrectOp:
	public OperatorThreaded,
	public Initialize<LengthCorrectOp>
{
	public:

					LengthCorrectOp(void)									{}
virtual				~LengthCorrectOp(void)									{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);
virtual	void		run(I32 a_id,Range a_range);

	private:

	sp<SurfaceAccessibleI>	m_spSurfaceAccessibleI;
	sp<SurfaceI>			m_spDriver;
};

} /* namespace */

#endif /* __operator_LengthCorrectOp_h__ */
