/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessibleBase_h__
#define __surface_SurfaceAccessibleBase_h__

namespace fe
{

/**************************************************************************//**
    @brief Common Functionality for Accessible Surface

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleBase:
	virtual public SurfaceAccessibleI
{
	public:
								SurfaceAccessibleBase(void)					{}
virtual							~SurfaceAccessibleBase(void)				{}

								//* as SurfaceAccessibleI

virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										String a_name,BWORD a_allowCreation)
								{	return sp<SurfaceAccessorI>(NULL); }
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute,BWORD a_allowCreation)
								{	return sp<SurfaceAccessorI>(NULL); }
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										String a_name)
								{
									return accessor(a_element,a_name,TRUE);
								}
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute)
								{
									return accessor(a_element,a_attribute,TRUE);
								}
};

} // namespace

#endif /* __surface_SurfaceAccessibleBase_h__ */
